Attribute VB_Name = "Global"
Option Explicit

Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long

Type POINTAPI
X As Long
Y As Long
End Type

Global Matrix(2, 2) As Byte
Global Steps(2) As POINTAPI
Global Turn As Boolean
Global GameEnd As Boolean
Global Pl2Com As Boolean
Global Point As POINTAPI

' Objects
Global Grid As New Grid
Global PlayerAI As New PlayerAI

Public Sub RefreshVariables()

If Game.Buff(1).AutoRedraw Then
Grid.BackgroundDC = Game.Buff(1).hdc
Grid.BackgroundWidth = Game.Buff(1).ScaleWidth
Grid.BackgroundHeight = Game.Buff(1).ScaleHeight
End If

If Game.Buff(2).AutoRedraw Then
Grid.BluePieceDC = Game.Buff(2).hdc
Grid.BluePieceHeight = Game.Buff(2).ScaleHeight
Grid.BluePieceWidth = Game.Buff(2).ScaleWidth
End If

If Game.Buff(3).AutoRedraw Then
Grid.RedPieceDC = Game.Buff(3).hdc
Grid.RedPieceHeight = Game.Buff(3).ScaleHeight
Grid.RedPieceWidth = Game.Buff(3).ScaleWidth
End If

Grid.BoardDC = Game.Board.hdc
Grid.BoardHeight = Game.Board.ScaleHeight
Grid.BoardWidth = Game.Board.ScaleWidth
Grid.SelectDC = Game.Buff(0).hdc

End Sub

Public Sub DrawImage(Buff As PictureBox, Path As String)

If Dir(Path) = "" Then
Buff.AutoRedraw = False ' Free the memory for the device contex
Exit Sub
End If

Game.Buff(0).Picture = LoadPicture(Path)
Buff.Width = Game.Buff(0).Width
Buff.Height = Game.Buff(0).Height
BitBlt Buff.hdc, 0, 0, Buff.Width, Buff.Height, Game.Buff(0).hdc, 0, 0, vbSrcCopy
Game.Buff(0).Picture = Nothing

End Sub

Public Function PlayerHasWon(ByRef RefMatrix() As Byte, Player As Byte) As Boolean

' This will check if a player have won

Dim A%, B%, C As Boolean

For A = 0 To 2
    C = False
    
    For B = 0 To 2
        If RefMatrix(A, B) <> Player Then C = True Else Steps(B).X = A: Steps(B).Y = B
    Next
    
    If C = False Then PlayerHasWon = True: Exit Function
Next


For A = 0 To 2
    C = False
    
    For B = 0 To 2
        If RefMatrix(B, A) <> Player Then C = True Else Steps(B).X = B: Steps(B).Y = A
    Next
    
    If C = False Then PlayerHasWon = True: Exit Function
Next


C = False
For A = 0 To 2
    If RefMatrix(A, A) <> Player Then C = True Else Steps(A).X = A: Steps(A).Y = A
Next
If C = False Then PlayerHasWon = True: Exit Function


C = False
For A = 0 To 2
    If RefMatrix(2 - A, A) <> Player Then C = True Else Steps(A).X = 2 - A: Steps(A).Y = A
Next
If C = False Then PlayerHasWon = True: Exit Function

End Function

Public Function AllFinish() As Boolean

Dim A%, B%, C As Boolean

For A = 0 To 2
For B = 0 To 2
If Matrix(A, B) = 0 Then C = True
Next
Next

AllFinish = Not C

End Function
