VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Grid"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function Ellipse Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, lpPoint As POINTAPI) As Long
Private Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function GdiTransparentBlt Lib "gdi32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal crTransparent As Long) As Boolean
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long

Private Const PS_SOLID = 0

Private lBackgroundDC&
Private lBluePieceDC&
Private lRedPieceDC&
Private lBoardDC&
Private lSelectDC&
Private lBoardWidth&
Private lBoardHeight&
Private lBackgroundWidth&
Private lBackgroundHeight&
Private lBluePieceHeight&
Private lBluePieceWidth&
Private lRedPieceHeight&
Private lRedPieceWidth&

Public Property Get BackgroundDC() As Long
BackgroundDC = lBackgroundDC
End Property

Public Property Let BackgroundDC(ByVal vNewValue As Long)
lBackgroundDC = vNewValue
End Property

Public Property Get BluePieceDC() As Long
BluePieceDC = lBluePieceDC
End Property

Public Property Let BluePieceDC(ByVal vNewValue As Long)
lBluePieceDC = vNewValue
End Property

Public Property Get RedPieceDC() As Long
RedPieceDC = lRedPieceDC
End Property

Public Property Let RedPieceDC(ByVal vNewValue As Long)
lRedPieceDC = vNewValue
End Property

Public Property Get BoardDC() As Long
BoardDC = lBoardDC
End Property

Public Property Let BoardDC(ByVal vNewValue As Long)
lBoardDC = vNewValue
End Property

Public Property Get SelectDC() As Long
SelectDC = lSelectDC
End Property

Public Property Let SelectDC(ByVal vNewValue As Long)
lSelectDC = vNewValue
End Property

Public Property Get BoardWidth() As Long
BoardWidth = lBoardWidth
End Property

Public Property Let BoardWidth(ByVal vNewValue As Long)
lBoardWidth = vNewValue
End Property

Public Property Get BoardHeight() As Long
BoardHeight = lBoardHeight
End Property

Public Property Let BoardHeight(ByVal vNewValue As Long)
lBoardHeight = vNewValue
End Property

Public Property Get BackgroundWidth() As Long
BackgroundWidth = lBackgroundWidth
End Property

Public Property Let BackgroundWidth(ByVal vNewValue As Long)
lBackgroundWidth = vNewValue
End Property

Public Property Get BackgroundHeight() As Long
BackgroundHeight = lBackgroundHeight
End Property

Public Property Let BackgroundHeight(ByVal vNewValue As Long)
lBackgroundHeight = vNewValue
End Property

Public Property Get BluePieceWidth() As Long
BluePieceWidth = lBluePieceWidth
End Property

Public Property Let BluePieceWidth(ByVal vNewValue As Long)
lBluePieceWidth = vNewValue
End Property

Public Property Get BluePieceHeight() As Long
BluePieceHeight = lBluePieceHeight
End Property

Public Property Let BluePieceHeight(ByVal vNewValue As Long)
lBluePieceHeight = vNewValue
End Property

Public Property Get RedPieceWidth() As Long
RedPieceWidth = lRedPieceWidth
End Property

Public Property Let RedPieceWidth(ByVal vNewValue As Long)
lRedPieceWidth = vNewValue
End Property

Public Property Get RedPieceHeight() As Long
RedPieceHeight = lRedPieceHeight
End Property

Public Property Let RedPieceHeight(ByVal vNewValue As Long)
lRedPieceHeight = vNewValue
End Property

Public Sub DrawPiece(ByVal x&, ByVal y&)

Dim XX%, YY%, Brush&, Pen&

Dim Buffer As String
Buffer = Space(200)

RefreshVariables
XX = x * (lBoardWidth / 3)
YY = y * (lBoardHeight / 3)

If Matrix(x, y) = 1 Then

If lBluePieceDC <> 0 Then
GdiTransparentBlt lBoardDC, XX, YY, lBluePieceWidth, lBluePieceHeight, lBluePieceDC, 0, 0, lBluePieceWidth, lBluePieceHeight, vbWhite
Else
    ' Without any image the program will draw a X
    Pen = CreatePen(PS_SOLID, 2, vbBlue)
    DeleteObject SelectObject(lBoardDC, Pen)
    MoveToEx lBoardDC, XX, YY, Point
    LineTo lBoardDC, XX + (lBoardWidth / 3), YY + (lBoardHeight / 3)
    MoveToEx lBoardDC, XX + (lBoardWidth / 3), YY, Point
    LineTo lBoardDC, XX, YY + (lBoardHeight / 3)
    End If

ElseIf Matrix(x, y) = 2 Then

If lRedPieceDC <> 0 Then
GdiTransparentBlt lBoardDC, XX, YY, lRedPieceWidth, lRedPieceHeight, lRedPieceDC, 0, 0, lRedPieceWidth, lRedPieceHeight, vbWhite
Else
    ' Without any image the program will draw a circle
    Pen = CreatePen(PS_SOLID, 1, vbBlack)
    DeleteObject SelectObject(lBoardDC, Pen)
    Brush = CreateSolidBrush(vbRed)
    DeleteObject SelectObject(lBoardDC, Brush)
    Ellipse lBoardDC, XX, YY, XX + (lBoardWidth / 3), YY + (lBoardWidth / 3)
    End If

End If

End Sub

Public Sub Draw()

Dim A%, B%

DrawBack

For A = 1 To 2
MoveToEx lBoardDC, A * (lBoardWidth / 3), 0, Point
LineTo lBoardDC, A * (lBoardWidth / 3), lBoardHeight
Next

For A = 1 To 2
MoveToEx lBoardDC, 0, A * (lBoardHeight / 3), Point
LineTo lBoardDC, lBoardWidth, A * (lBoardHeight / 3)
Next

End Sub

Public Sub DrawBack()

Dim A%, B%

RefreshVariables
If lBackgroundWidth = 0 Or lBackgroundHeight = 0 Then Exit Sub

For A = 0 To Int(BoardWidth / lBackgroundWidth)
For B = 0 To Int(BoardHeight / lBackgroundHeight)
BitBlt lBoardDC, A * lBackgroundWidth, B * lBackgroundHeight, lBackgroundWidth, lBackgroundHeight, lBackgroundDC, 0, 0, vbSrcCopy
Next
Next

End Sub

Public Sub SelectPiece(ByVal x%, ByVal y%)

BitBlt BoardDC, x * (lBoardWidth / 3), y * (lBoardHeight / 3), lBoardWidth / 3, lBoardHeight / 3, lSelectDC, 0, 0, vbSrcAnd

End Sub

Public Sub BoardMouseDown(ByVal x%, ByVal y%)

Dim A&, B&, XX%, YY%

A = Int(x / (lBoardWidth / 3))
B = Int(y / (lBoardHeight / 3))

If Matrix(A, B) <> 0 Or GameEnd Then Exit Sub
Matrix(A, B) = IIf(Turn, 2, 1)
DrawPiece A, B

XX = A * (lBoardWidth / 3)
YY = B * (lBoardHeight / 3)

If PlayerHasWon(Matrix, IIf(Turn, 2, 1)) Then

For A = 0 To 2
Grid.SelectPiece Steps(A).x, Steps(A).y
Next

Game.Board.Refresh
Game.Text.Caption = "Press new game in the file menu to begin"
GameEnd = True
Exit Sub
End If

Game.Board.Refresh
Grid.BoardDC = Game.Board.hdc

Turn = Not Turn
Game.Text.Caption = "It's player " & IIf(Turn, "red", "blue") & "s turn"

If Turn And Pl2Com Then
PlayerAI.PlayerAI A, B
BoardMouseDown A * (lBoardWidth / 3) + (lBoardWidth / 6), B * (lBoardHeight / 3) + (lBoardHeight / 6)
End If

If AllFinish Then
Game.Text.Caption = "Press new game in the file menu to begin"
GameEnd = True
End If

End Sub
